%define compatv 72
%{?compatv:%define compatfv 7.2}

%define _phplib %{_libdir}/php%{?compatv}
%define _extdir %{_phplib}/extensions
%define _devver 3.x

%define _m2rev beff63f
%define _m3rev e702b5f

Summary: PHP %{?compatfv} PECL memcache v2 & v3 extension
Summary(ko): PHP %{?compatfv} PECL memcache v2 & v3 확장
Name: php%{?compatv}-pecl-memcache
Version: 2.2.7
Release: 6%{?dist}
Epoch: 100
Group: Development/Languages
License: PHP
URL: https://github.com/websupport-sk/pecl-memcache/tree/php7
Source0: https://github.com/websupport-sk/pecl-memcache/archive/php7.zip#/memcache-%{version}-php7-%{_m2rev}.tar.bz2
Source1: https://github.com/websupport-sk/pecl-memcache/archive/NON_BLOCKING_IO_php7.zip#/memcache-3.0.9-php7-nonblockingio-%{_m3rev}.tar.bz2
Patch0: memcache-3.0.9-pr23-read-session-data.patch
Patch1: memcache-3.0.9-pr30-73-build-warning-1.patch
Patch2: memcache-3.0.9-pr30-73-build-warning-2.patch


BuildRoot: /var/tmp/%{name}-root
Requires: php%{?compatv}api
BuildRequires: php%{?compatv}-devel
Provides: php%{?compatv}-pecl(memcache)
Provides: php%{?compatv}-memcache

%description
PHP PECL memcache APIs

%prep
%setup -q -n memcache

tar xvfpj %{SOURCE1}
cd memcache
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build

CFLAGS="${RPM_OPT_FLAGS}"

/usr/bin/phpize%{?compatv}
./configure --with-libdir=lib64

%{__make} %{?_smp_mflags}

cd memcache
/usr/bin/phpize%{?compatv}
./configure --with-libdir=lib64

%{__make} %{?_smp_mflags}
cd -

%install
[ "%{buildroot}" != "/" -a -d "%{buildroot}" ] && %{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_extdir}

%{__install} -m755 modules/memcache.so %{buildroot}%{_extdir}/
%{__install} -m755 memcache/modules/memcache.so %{buildroot}%{_extdir}/memcache-%{_devver}.so

%{__mkdir_p} %{buildroot}%{_sysconfdir}/php%{?compatv}.d/{%{!?compatv:apache},cli,fpm}
for i in %{!?compatv:apache} cli fpm
do
	%{__cat} > %{buildroot}%{_sysconfdir}/php%{?compatv}.d/$i/memcache.ini <<EOF
;
; Memcache extension
;
; Warning!
; Never enable both memcache.so and memcache-%{_devver}.so
;
extension = memcache
;extension = memcache-%{_devver}
EOF
done

%clean
[ "%{buildroot}" != "/" -a -d "%{buildroot}" ] && %{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%attr(755,root,root) %{_extdir}/memcache.so
%attr(755,root,root) %{_extdir}/memcache-%{_devver}.so
%{!?compatv:%config(noreplace) %{_sysconfdir}/php%{?compatv}.d/apache/memcache.ini}
%config(noreplace) %{_sysconfdir}/php%{?compatv}.d/cli/memcache.ini
%config(noreplace) %{_sysconfdir}/php%{?compatv}.d/fpm/memcache.ini

%changelog
* Sat Jul 21 2018 JoungKyun.Kim <hostmaster@oops.org> 100:2.2.7-6%{?dist}
- 3.0.x
  . fixed #23 Failed to read session data with 7.1/7.2 
  . fixed #30 PHP 7.3 + fix build warnings 

* Sat Feb 10 2018 JoungKyun.Kim <hostmaster@oops.org> 100:2.2.7-5%{?dist}
- 3.0.x
  . fixed #20 memcache session handler with two backend servers Fatal Error (out of memory)
    https://bugs.php.net/bug.php?id=73539
  . fixed #16 move connect to proper section to make SKIP work (df7735e)

* Fri May 26 2017 JoungKyun.Kim <http://oops.org> 100:2.2.7-4%{?dist}
- 3.0.x
  . fixed #24 PHP7 segfault. https://bugs.php.net/bug.php?id=74008 (95b7076)
- 2.2.x
  . Apply patch for php bug 73539 (beff63f)

* Fri Dec 16 2016 JoungKyun.Kim <hostmaster@oops.org> 100:2.2.7-3%{?dist}
- fixed #14 Change timeout parameter to double (68c495e) on v3.0.9

* Fri Aug  5 2016 JoungKyun.Kim <hostmaster@oops.org> 100:2.2.7-2%{?dist}
- fixed #5 Fixed invalid int -> size_t in params
- fixed #6 Update to clean up compilation warnings
- add 3.0.9-dev tree (memcache-3x.so)

* Sat Jan  9 2016 JoungKyun.Kim <hostmaster@oops.org> 100:2.2.7-1%{?dist}
- update 2.2.7 memcache extension

